package array;
/**
 * 题目： 26. 删除有序数组中的重复项 (removeDuplicates)
 * 描述：给你一个 非严格递增排列 的数组 nums ，请你 原地 删除重复出现的元素，使每个元素 只出现一次 ，返回删除后数组的新长度。元素的 相对顺序 应该保持 一致 。然后返回 nums 中唯一元素的个数。
 * 考虑 nums 的唯一元素的数量为 k ，你需要做以下事情确保你的题解可以被通过：
 * 更改数组 nums ，使 nums 的前 k 个元素包含唯一元素，并按照它们最初在 nums 中出现的顺序排列。nums 的其余元素与 nums 的大小不重要。
 * 返回 k 。
 *
 * 示例 1：
 输入：nums = [1,1,2]
 输出：2, nums = [1,2,_]
 解释：函数应该返回新的长度 2 ，并且原数组 nums 的前两个元素被修改为 1, 2 。不需要考虑数组中超出新长度后面的元素。

 * 链接：https://leetcode.cn/problems/remove-duplicates-from-sorted-array/
 */
public class RemoveDuplicates {
    //很啰嗦
    public int removeDuplicates2(int[] nums) {
        int pre=0,deleted=0,start=0,invalid=Integer.MIN_VALUE;
        for (int i = 1; i < nums.length; i++) {
            if(nums[i]==nums[pre]) {
                nums[i] = invalid;
                deleted++;
            }
            else
                pre=i;
        }
        for (int i = 1; i < nums.length-deleted; i++) {
            if(nums[i]==invalid){
                int j;
                if(start==0)
                    j=i+1;
                else
                    j=start;
                while (j<nums.length){
                    if(nums[j]!=invalid) {
                        nums[i] = nums[j];
                        nums[j]=invalid;
                        start=j+1;
                        break;
                    }
                    j++;
                }
            }
        }
        return nums.length-deleted;
    }
    //双指针

    /**
     * 我们可以直接用「双指针」在一次遍历里完成所有操作：
     *
     * 慢指针 write：指向下一个要写入唯一元素的位置
     * 快指针 read：扫描整个数组
     * 当 nums[read] != nums[read - 1] 时，就把它写到 nums[write++] 上
     * @param nums
     * @return
     */
    public int removeDuplicates(int[] nums) {
        if (nums.length == 0) return 0;
        // write 指向下一次写入的位置，初始写 nums[0]
        int write = 1;
        // read 从 1 开始扫描到末尾
        for (int read = 1; read < nums.length; read++) {
            // 只有当遇到新值时，才写入，并推进 write
            if (nums[read] != nums[read - 1]) {
                nums[write] = nums[read];
                write++;
            }
        }
        return write;
    }
}
