package array;
/**
 * 题目： 27. 移除元素 (removeElement)
 * 描述：给你一个数组 nums 和一个值 val，你需要 原地 移除所有数值等于 val 的元素。元素的顺序可能发生改变。然后返回 nums 中与 val 不同的元素的数量。
 * 假设 nums 中不等于 val 的元素数量为 k，要通过此题，您需要执行以下操作：
 * 更改 nums 数组，使 nums 的前 k 个元素包含不等于 val 的元素。nums 的其余元素和 nums 的大小并不重要。
 * 返回 k。
 *
 *
 * 示例 1：
 输入：nums = [3,2,2,3], val = 3
 输出：2, nums = [2,2,_,_]
 解释：你的函数函数应该返回 k = 2, 并且 nums 中的前两个元素均为 2。
 你在返回的 k 个元素之外留下了什么并不重要（因此它们并不计入评测）。

 * 链接：https://leetcode.cn/problems/remove-element/
 */
public class RemoveElement {
    public int removeElement1(int[] nums, int val) {
        int n=nums.length,chosen=0;
        for (int i = 0; i < n; i++) {
            if(nums[i]==val) {
                nums[i] = -1;
                chosen++;
            }
        }
        for (int i = 0; i < n-chosen; i++) {
            if(nums[i]==-1){
                for (int j = n-1; j > i; j--) {
                    if(nums[j]!=-1) {
                        nums[i] = nums[j];
                        nums[j]=-1;
                        break;
                    }
                }
            }
        }
        return n-chosen;
    }
    //双指针
    public int removeElement(int[] nums, int val) {
        int i = 0, j = nums.length - 1;
        while (i <= j) {
            if (nums[i] == val) {
                // 把尾部的元素换到 i 位置
                nums[i] = nums[j];
                // 尾部换下来的这个位置，无论是不是 val，都算处理过了
                j--;
            } else {
                // nums[i] 本身就不是 val，保留，继续往前
                i++;
            }
        }
        // i 最终停在第一个“应该被移除”的位置，
        // 也就是有 i 个非 val 元素
        return i;
    }
}
