package array;
/**
 * 题目：189. 轮转数组 (rotate)
 * 描述：给定一个整数数组 nums，将数组中的元素向右轮转 k 个位置，其中 k 是非负数。

 * 链接：https://leetcode.cn/problems/rotate-array/
 示例 1:
 输入: nums = [1,2,3,4,5,6,7], k = 3
 输出: [5,6,7,1,2,3,4]
 解释:
 向右轮转 1 步: [7,1,2,3,4,5,6]
 向右轮转 2 步: [6,7,1,2,3,4,5]
 向右轮转 3 步: [5,6,7,1,2,3,4]

 示例 2:
 输入：nums = [-1,-100,3,99], k = 2
 输出：[3,99,-1,-100]
 解释:
 向右轮转 1 步: [99,-1,-100,3]
 向右轮转 2 步: [3,99,-1,-100]
 */

public class RotateArray {
    public void rotateArray(int[] nums, int k) {
        int cnt=nums.length,index=0;
        int offset=k%cnt;
        int[]temp=new int[k];
        for (int i = cnt-offset; i < cnt; i++) {
            temp[index]=nums[i];
            index++;
        }
        for (int i = cnt-1; i>=offset ; i--) {
            nums[i]=nums[i-offset];
        }
        for (int i = 0; i < offset; i++) {
            nums[i]=temp[i];
        }
    }
}
