package binary_search;
/**
 * 题目： 35. 搜索插入位置 (floodFill)
 * 描述：给定一个排序数组和一个目标值，在数组中找到目标值，并返回其索引。如果目标值不存在于数组中，返回它将会被按顺序插入的位置。
 * 请必须使用时间复杂度为 O(log n) 的算法。

 *
 * 示例 1：
 输入: nums = [1,3,5,6], target = 5
 输出: 2

 * 链接：https://leetcode.cn/problems/search-insert-position/
 */
//第一道二分法的题，不熟练
public class SearchInsert {
    public int searchInsert(int[] nums, int target) {
        int left = 0, right = nums.length - 1;
        while (left <= right) {
            int mid = (right + left) / 2;
            if (nums[mid] == target) {
                return mid;
            } else if (nums[mid] < target) {
                left = mid + 1;
            } else {
                right = mid - 1;
            }
        }
        return left;
    }

    private int helper(int[] nums, int target, int left, int right) {
        if (left > right) {
            return left;
        }
        int mid = (right + left) / 2;
        if (nums[mid] == target) {
            return mid;
        } else if (nums[mid] < target) {
            return helper(nums, target, mid + 1, right);
        } else {
            return helper(nums, target, left, mid - 1);
        }
    }

    public int searchInsert1(int[] nums, int target) {
        return helper(nums, target, 0, nums.length - 1);
    }
}
