package binary_search;
/**
 * 题目： 74. 搜索二维矩阵 (searchMatrix)
 * 描述：给你一个满足下述两条属性的 m x n 整数矩阵：
 *
 * 每行中的整数从左到右按非严格递增顺序排列。
 * 每行的第一个整数大于前一行的最后一个整数。
 * 给你一个整数 target ，如果 target 在矩阵中，返回 true ；否则，返回 false 。

 *
 * 示例 1：
 输入：matrix = [[1,3,5,7],[10,11,16,20],[23,30,34,60]], target = 3
 输出：true

 * 链接：https://leetcode.cn/problems/search-a-2d-matrix/
 */
public class SearchMatrix {
    public boolean searchMatrix(int[][] matrix, int target) {
        int r=matrix.length;
        int c=matrix[0].length;
        int i=0,j=c-1;
        while (i<=r-1 && j>=0){
            if(target==matrix[i][j])
                return true;
            else if(target>matrix[i][j])
                i++;
            else
                j--;
        }
        return false;
    }
}
