package bitwise;
/**
 * 题目： 67. 二进制求和 (addBinary)
 * 描述：给你两个二进制字符串 a 和 b ，以二进制字符串的形式返回它们的和。
 *
 * 示例 1：
 输入:a = "11", b = "1"
 输出："100"

 * 链接：https://leetcode.cn/problems/add-binary/
 */
public class AddBinary {
    public String addBinary(String a, String b) {
        int len1=a.length(),len2=b.length();
        int done=0;
        int carry=0;
        int cura,curb;
        StringBuilder sb=new StringBuilder();
        while (done<Math.max(len1,len2)){
            if(done<len1)
                cura=a.charAt(len1-1-done)-'0';
            else cura=0;
            if(done<len2)
                curb=b.charAt(len2-1-done)-'0';
            else curb=0;
            int cur=(cura+curb+carry)%2;
            carry=(cura+curb+carry)/2;
            sb.insert(0,cur);
            done++;
        }

        if(carry==1)sb.insert(0,'1');
        return sb.toString();
    }
}
