package hash;
/**
 * 题目： 242. 有效的字母异位词 (isAnagram)
 * 描述：给定两个字符串 s 和 t ，编写一个函数来判断 t 是否是 s 的 字母异位词。
 *字母异位词是通过重新排列不同单词或短语的字母而形成的单词或短语，并使用所有原字母一次。
 *
 * 示例 1：
 输入: s = "anagram", t = "nagaram"
 输出: true

 * 链接：https://leetcode.cn/problems/valid-anagram/
 */
public class IsAnagram {
    public boolean isAnagram(String s, String t) {
        if(s.length() != t.length())
            return false;
        int[] alpha = new int[26];
        for(int i = 0; i< s.length(); i++) {
            alpha[s.charAt(i) - 'a'] ++;
            alpha[t.charAt(i) - 'a'] --;
        }
        for(int i=0;i<26;i++)
            if(alpha[i] != 0)
                return false;
        return true;
    }
}
