package linkedlist;
/**
 * 题目：206. 反转链表  (reverseList)
 * 描述：给你单链表的头节点 head ，请你反转链表，并返回反转后的链表。

 * 链接：https://leetcode.cn/problems/reverse-linked-list/

 */
public class ReverseList {
    public ListNode reverseList(ListNode head) {
        ListNode prev = null;
        ListNode curr = head;
        while (curr != null) {
            ListNode next = curr.next;
            curr.next = prev;
            prev = curr;
            curr = next;
        }
        return prev;
    }
}
