package linkedlist;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

/**
 * 题目： 148. 排序链表  (sortList)
 * 描述：给你链表的头结点 head ，请将其按 升序 排列并返回 排序后的链表 。

 * 链接：https://leetcode.cn/problems/sort-list/

 */
public class SortList {
    public ListNode sortList(ListNode head) {
        ListNode cur=head;
        List<Integer>list=new ArrayList<>();
        while (cur!=null){
            list.add(cur.val);
            cur=cur.next;
        }
        Collections.sort(list);
        ListNode pre=new ListNode(-1);
        ListNode newnode=pre;
        for (Integer integer : list) {
            pre.next= new ListNode(integer);
            pre=pre.next;
        }
        return newnode.next;
    }
}
