package matrix;

import java.util.HashSet;

/**
 * 题目：73. 矩阵置零 (setZeroes)
 * 描述：给定一个 m x n 的矩阵，如果一个元素为 0 ，则将其所在行和列的所有元素都设为 0 。请使用 原地 算法。

 * 链接：https://leetcode.cn/problems/set-matrix-zeroes/
 示例 1:
 输入：matrix = [[1,1,1],[1,0,1],[1,1,1]]
 输出：[[1,0,1],[0,0,0],[1,0,1]]

 示例 2:
 输入：matrix = [[0,1,2,0],[3,4,5,2],[1,3,1,5]]
 输出：[[0,0,0,0],[0,4,5,0],[0,3,1,0]]
 */
public class SetZeroes {
    public void setZeroes(int[][] matrix) {
        int row=matrix.length;
        int col=matrix[0].length;
        HashSet<Integer>iset=new HashSet<>();
        HashSet<Integer>jset=new HashSet<>();
        for (int i = 0; i < row; i++) {
            for (int j = 0; j < col; j++) {
                if(matrix[i][j]==0) {
                    iset.add(i);
                    jset.add(j);
                }
            }
        }
        for (Integer integer : iset) {
            for (int j = 0; j < col; j++) {
                matrix[integer][j]=0;
            }
        }
        for (Integer integer : jset) {
            for (int i = 0; i < row; i++) {
                matrix[i][integer]=0;
            }
        }
    }
}
