package tree;

import java.util.ArrayList;
import java.util.LinkedList;
import java.util.List;
import java.util.Queue;

/**
 * 题目： 637. 二叉树的层平均值 (averageOfLevels)
 * 描述：给定一个非空二叉树的根节点 root , 以数组的形式返回每一层节点的平均值。与实际答案相差 10-5 以内的答案可以被接受。
 *
 示例 1：
 输入：root = [3,9,20,null,null,15,7]
 输出：[3.00000,14.50000,11.00000]
 解释：第 0 层的平均值为 3,第 1 层的平均值为 14.5,第 2 层的平均值为 11 。
 因此返回 [3, 14.5, 11] 。

 * 链接：https://leetcode.cn/problems/average-of-levels-in-binary-tree/
 */
public class AverageOfLevels {
    public List<Double> averageOfLevels(TreeNode root) {
        Queue<TreeNode>queue=new LinkedList<>();
        List<Double>res=new ArrayList<>();
        queue.offer(root);
        while (!queue.isEmpty()){
            int size=queue.size();
            double sum=0.0;
            for (int i = 0; i < size; i++) {
                TreeNode cur=queue.poll();
                sum+=cur.val;
                if(cur.left!=null)queue.offer(cur.left);
                if(cur.right!=null)queue.offer(cur.right);
            }
            res.add(sum/size);
        }
        return res;
    }
}
