package tree;
/**
 * 题目： 106. 从中序与后序遍历序列构造二叉树 (buildTree)
 * 描述：给定两个整数数组 inorder 和 postorder ，其中 inorder 是二叉树的中序遍历， postorder 是同一棵树的后序遍历，请你构造并返回这颗 二叉树 。

 示例 2：
 输入：inorder = [9,3,15,20,7], postorder = [9,15,7,20,3]
 输出：[3,9,20,null,null,15,7]

 * 链接：https://leetcode.cn/problems/construct-binary-tree-from-inorder-and-postorder-traversal/
 */
public class BuildTree2 {
    int find_pos(Integer num,int[] inorder,int i,int j){
        for (int k = i;k <= j; k++) {
            if(num==inorder[k])
                return k;
        }
        return 0;
    }
    TreeNode func(int[] inorder, int[] postorder,int l_in,int r_in,int l_post,int r_post){
        if(l_in>r_in||l_post>r_post)
            return null;
        int cur=postorder[r_post];
        int pos=find_pos(cur,inorder,l_in,r_in);
        int l_cnt=pos-l_in;
        TreeNode node=new TreeNode(cur);
        node.left=func(inorder,postorder,l_in,pos-1,l_post,l_post+l_cnt-1);
        node.right=func(inorder,postorder,pos+1,r_in,l_post+l_cnt,r_post-1);
        return node;
    }
    public TreeNode buildTree(int[] inorder, int[] postorder) {
        return func(inorder,postorder,0,inorder.length-1,0,postorder.length-1);
    }
}
