package tree;
/**
 * 题目： 112. 路径总和 (buildTree)
 * 描述：给你二叉树的根节点 root 和一个表示目标和的整数 targetSum 。判断该树中是否存在 根节点到叶子节点 的路径，这条路径上所有节点值相加等于目标和 targetSum 。如果存在，返回 true ；否则，返回 false 。
 * 叶子节点 是指没有子节点的节点。
 *
 示例 1：
 输入：root = [5,4,8,11,null,13,4,7,2,null,null,null,1], targetSum = 22
 输出：true
 解释：等于目标和的根节点到叶节点路径如上图所示。

 * 链接：https://leetcode.cn/problems/path-sum/
 */
public class HasPathSum {
    boolean dfs(TreeNode root,int curSum,int target){
        if(root==null)return false;
        curSum+=root.val;
        if(root.right==null&&root.left==null){
            if(curSum==target)return true;
        }
        return dfs(root.left,curSum,target) || dfs(root.right,curSum,target);
    }
    public boolean hasPathSum(TreeNode root, int targetSum) {
        return dfs(root,0,targetSum);
    }
}
