package tree;

/**
 * 题目： 100. 相同的树 (isSameTree)
 * 描述：给你两棵二叉树的根节点 p 和 q ，编写一个函数来检验这两棵树是否相同。
 * 如果两个树在结构上相同，并且节点具有相同的值，则认为它们是相同的。

 示例 2：
 输入：p = [1,2,3], q = [1,2,3]
 输出：true

 * 链接：https://leetcode.cn/problems/same-tree/
 */
public class IsSameTree {
    public boolean isSameTree(TreeNode p, TreeNode q) {
        if (p == null && q == null) {
            return true;
        } else if (p == null || q == null) {
            return false;
        } else if (p.val != q.val) {
            return false;
        } else {
            return isSameTree(p.left, q.left) && isSameTree(p.right, q.right);
        }
    }
}
