package tree;

import java.util.ArrayList;
import java.util.List;

/**
 * 题目： 230. 二叉搜索树中第 K 小的元素  (sortedArrayToBST)
 * 描述：给定一个二叉搜索树的根节点 root ，和一个整数 k ，请你设计一个算法查找其中第 k 小的元素（从 1 开始计数）。

 * 链接：https://leetcode.cn/problems/kth-smallest-element-in-a-bst/

 */
public class KthSmallest {
    //中序遍历
    public void dfs(TreeNode root, List<Integer> list){
        if(root!=null){
            dfs(root.left,list);
            list.add(root.val);
            dfs(root.right,list);
        }
    }
    public int kthSmallest(TreeNode root, int k) {
        List<Integer>list=new ArrayList<>();
        dfs(root,list);
        return list.get(k-1);
    }
}
