package tree;

import java.util.ArrayList;
import java.util.LinkedList;
import java.util.List;
import java.util.Queue;

/**
 * 题目： 102. 二叉树的层序遍历  (levelOrder)
 * 描述：给你二叉树的根节点 root ，返回其节点值的 层序遍历 。 （即逐层地，从左到右访问所有节点）。

 * 链接：https://leetcode.cn/problems/binary-tree-level-order-traversal/

 */
public class LevelOrder {
    public List<List<Integer>> levelOrder(TreeNode root) {
        List<List<Integer>>res=new ArrayList<>();
        if(root==null)
            return new ArrayList<>();
        Queue<TreeNode>queue=new LinkedList<>();
        queue.offer(root);
        while (!queue.isEmpty()){
            int levelSize = queue.size();
            List<Integer>list=new ArrayList<>();
            for (int i = 0; i < levelSize; i++) {
                TreeNode tp=queue.poll();
                list.add(tp.val);
                if(tp.left!=null) {
                    queue.offer(tp.left);
                }
                if(tp.right!=null) {
                    queue.offer(tp.right);
                }
            }
            res.add(list);
        }
        return res;
    }
}
