package array;
/**
 * 题目： 58. 最后一个单词的长度 (lengthOfLastWord)
 * 描述：给你一个字符串 s，由若干单词组成，单词前后用一些空格字符隔开。返回字符串中 最后一个 单词的长度。
 *
 * 单词 是指仅由字母组成、不包含任何空格字符的最大子字符串。
 *
 * 示例 1：
 输入：s = "Hello World"
 输出：5
 解释：最后一个单词是“World”，长度为 5。

 * 链接：https://leetcode.cn/problems/length-of-last-word/
 */
public class LengthOfLastWord {
    public int lengthOfLastWord(String s) {
        int total=s.length();
        int begin=-1,end=total;
        for (int i = total-1; i >=0.; i--) {
            char cur=s.charAt(i);
            if(end==total&&cur==' ') {
            }
            else if(end == total) end=i;
            else {
                if (cur == ' ') {
                    begin = i;
                    break;
                }
            }
        }
        return end-begin;
    }
    public int lengthOfLastWord2(String s) {
        int index = s.length() - 1;
        while (s.charAt(index) == ' ') {
            index--;
        }
        int wordLength = 0;
        while (index >= 0 && s.charAt(index) != ' ') {
            wordLength++;
            index--;
        }
        return wordLength;
    }
}
