package array;
/**
 * 题目： 80. 删除有序数组中的重复项 II (removeDuplicates)
 * 描述：给你一个有序数组 nums ，请你 原地 删除重复出现的元素，使得出现次数超过两次的元素只出现两次 ，返回删除后数组的新长度。
 * 不要使用额外的数组空间，你必须在 原地 修改输入数组 并在使用 O(1) 额外空间的条件下完成。
 *
 * 示例 1：
 输入：nums = [1,1,1,2,2,3]
 输出：5, nums = [1,1,2,2,3]
 解释：函数应返回新长度 length = 5, 并且原数组的前五个元素被修改为 1, 1, 2, 2, 3。 不需要考虑数组中超出新长度后面的元素。

 * 链接：https://leetcode.cn/problems/remove-duplicates-from-sorted-array-ii/
 */
public class RemoveDuplicates2 {
    //自己写的
    public int removeDuplicates(int[] nums) {
        int tpcnt=1,prenum=nums[0],write=0;
        for (int i = 1; i < nums.length; i++) {
            if(nums[i]==prenum){
                tpcnt++;
            }else{
                tpcnt=1;
                prenum=nums[i];
            }
            if(tpcnt<=2) {
                write++;
                nums[write] = nums[i];
            }
        }
        return write+1;
    }
    //标准答案
    public int removeDuplicates2(int[] nums) {
        if (nums.length <= 2) return nums.length;
        int write = 2;        // 已保留的区间长度至少为 2
        for (int i = 2; i < nums.length; i++) {
            // 只要当前 nums[i] 跟已经保留区的倒数第 2 个不同，就可以写入
            if (nums[i] != nums[write - 2]) {
                nums[write] = nums[i];
                write++;
            }
        }
        return write;
    }
}
