package array;
/**
 * 题目： 28. 找出字符串中第一个匹配项的下标 (strStr)
 * 描述：给你两个字符串 haystack 和 needle ，请你在 haystack 字符串中找出 needle 字符串的第一个匹配项的下标（下标从 0 开始）。如果 needle 不是 haystack 的一部分，则返回  -1 。
 *
 * 示例 1：
 输入：haystack = "sadbutsad", needle = "sad"
 输出：0
 解释："sad" 在下标 0 和 6 处匹配。
 第一个匹配项的下标是 0 ，所以返回 0 。

 * 链接：https://leetcode.cn/problems/find-the-index-of-the-first-occurrence-in-a-string/
 */
public class StrStr {
    public int strStr(String haystack, String needle) {
        int sz1=haystack.length();
        int sz2=needle.length();
        for (int i = 0; i <= sz1-sz2; i++) {
            if(haystack.substring(i,i+sz2).equals(needle))
                return i;
        }
        return -1;
    }
}
