package binary_search;
/**
 * 题目： 162. 寻找峰值  (findPeakElement)
 * 描述：峰值元素是指其值严格大于左右相邻值的元素。
 * 给你一个整数数组 nums，找到峰值元素并返回其索引。数组可能包含多个峰值，在这种情况下，返回 任何一个峰值 所在位置即可。
 * 你可以假设 nums[-1] = nums[n] = -∞ 。
 * 你必须实现时间复杂度为 O(log n) 的算法来解决此问题。
 *
 示例 1：
 输入：nums = [1,2,3,1]
 输出：2
 解释：3 是峰值元素，你的函数应该返回其索引 2。
 *
 * 链接：https://leetcode.cn/problems/find-peak-element/

 */
public class FindPeakElement {
    public int findPeakElement1(int[] nums) {
        int pre=Integer.MIN_VALUE;
        for (int i = 0; i < nums.length-1; i++) {
            int cur=nums[i];
            int next=nums[i+1];
            if(pre<cur&&cur>next)
                return i;
            pre=cur;
        }
        if(nums[nums.length-1]>pre)
            return nums.length-1;
        else return 0;
    }
    //二分查找 Ologn
    public int findPeakElement(int[] nums) {
        int l = 0, r = nums.length - 1;
        while (l < r) {
            int mid = l + (r - l) / 2;
            // 如果右侧更“高”，就在右半区继续寻找
            if (nums[mid] < nums[mid + 1]) {
                l = mid + 1;
            } else {
                // 否则峰值在左半区（包括 mid 自身）
                r = mid;
            }
        }
        // l == r，即为峰值下标
        return l;
    }
}
