package bitwise;
/**
 * 题目： 191. 位1的个数 (HammingWeight)
 * 描述：给定一个正整数 n，编写一个函数，获取一个正整数的二进制形式并返回其二进制表达式中 设置位 的个数（也被称为汉明重量）。
 *
 *
 * 示例 1：
 输入：n = 11
 输出：3
 解释：输入的二进制串 1011 中，共有 3 个设置位。

 * 链接：https://leetcode.cn/problems/number-of-1-bits/
 */
public class HammingWeight {
    public int hammingWeight(int n) {
        int ret = 0;
        for (int i = 0; i < 32; i++) {
            if ((n & (1 << i)) != 0) {
                ret++;
            }
        }
        return ret;
    }
}
