package digit;
/**
 * 题目： 172. 阶乘后的零 (trailingZeroes)
 * 描述：给定一个整数 n ，返回 n! 结果中尾随零的数量。
 *
 * 提示 n! = n * (n - 1) * (n - 2) * ... * 3 * 2 * 1
 *
 示例 1：
 输入：n = 3
 输出：0
 解释：3! = 6 ，不含尾随 0

 * 链接：https://leetcode.cn/problems/factorial-trailing-zeroes/
 */
//先求阶乘会导致整数溢出，20! 就已经无法放进 64 位整数。
public class TrailingZeroes {
    //正确做法：统计因子5出现的次数：n/5+n/(5∗5)+n/(5∗5∗5)+...
    public int trailingZeroes(int n) {
        int count = 0;
        // 每次除以 5，累加能贡献一个额外 5 的数目
        while (n > 0) {
            n /= 5;
            count += n;
        }
        return count;
    }
}
