package dynamic_programming;
/**
 * 题目： 518. 零钱兑换 II (change)
 * 描述：给你一个整数数组 coins 表示不同面额的硬币，另给一个整数 amount 表示总金额。
 * 请你计算并返回可以凑成总金额的硬币组合数。如果任何硬币组合都无法凑出总金额，返回 0 。
 * 假设每一种面额的硬币有无限个。
 * 题目数据保证结果符合 32 位带符号整数。

 示例 2：
 输入：amount = 5, coins = [1, 2, 5]
 输出：4
 解释：有四种方式可以凑成总金额：
 5=5
 5=2+2+1
 5=2+1+1+1
 5=1+1+1+1+1

 * 链接：https://leetcode.cn/problems/coin-change-ii/
 */
public class Change {
    public int change(int amount, int[] coins) {
        int[]dp=new int[amount+1];
        dp[0]=1;
        for (int coin : coins) {
            for (int j = 0; j <= amount; j++) {
                if (j - coin >= 0)
                    dp[j] += dp[j - coin];
            }
        }
        return dp[amount];
    }
}
