package dynamic_programming;
/**
 * 题目： 377. 组合总和 Ⅳ (CombinationSum4 )
 * 描述：给你一个由 不同 整数组成的数组 nums ，和一个目标整数 target 。请你从 nums 中找出并返回总和为 target 的元素组合的个数。
 * 题目数据保证答案符合 32 位整数范围。

 示例 2：
 输入：nums = [1,2,3], target = 4
 输出：7
 解释：
 所有可能的组合为：
 (1, 1, 1, 1)
 (1, 1, 2)
 (1, 2, 1)
 (1, 3)
 (2, 1, 1)
 (2, 2)
 (3, 1)
 请注意，顺序不同的序列被视作不同的组合。

 * 链接：https://leetcode.cn/problems/combination-sum-iv/
 */
public class CombinationSum4 {
    public int combinationSum4(int[] nums, int target) {
        int[]dp=new int[target+1];
        dp[0]=1;
        for (int j = 0; j <= target; j++) {
            for (int num : nums) {
                if(j-num>=0)
                    dp[j] += dp[j - num];
            }
        }
        return dp[target];
    }
}
