package dynamic_programming;

import java.util.ArrayList;
import java.util.List;

/**
 * 题目： 118. 杨辉三角 (generate)
 * 描述：给定一个非负整数 numRows，生成「杨辉三角」的前 numRows 行。
 * 在「杨辉三角」中，每个数是它左上方和右上方的数的和。

 示例 2：
 输入: numRows = 5
 输出: [[1],[1,1],[1,2,1],[1,3,3,1],[1,4,6,4,1]]

 * 链接：https://leetcode.cn/problems/pascals-triangle/
 */
public class Generate {
    public List<List<Integer>> generate(int numRows) {
        List<List<Integer>>res=new ArrayList<>();
        List<Integer>pre = null;
        for (int i = 0; i < numRows; i++) {
            List<Integer>temp=new ArrayList<>();
            for (int j = 0; j < i+1; j++) {
                if(j==0||j==i)
                    temp.add(1);
                else temp.add(pre.get(j-1)+pre.get(j));
            }
            res.add(temp);
            pre=new ArrayList<>(temp);
        }
        return res;
    }
    //官方题解 差不多
    public List<List<Integer>> generate1(int numRows) {
        List<List<Integer>> ret = new ArrayList<List<Integer>>();
        for (int i = 0; i < numRows; ++i) {
            List<Integer> row = new ArrayList<Integer>();
            for (int j = 0; j <= i; ++j) {
                if (j == 0 || j == i) {
                    row.add(1);
                } else {
                    row.add(ret.get(i - 1).get(j - 1) + ret.get(i - 1).get(j));
                }
            }
            ret.add(row);
        }
        return ret;
    }
}
