package dynamic_programming;
/**
 * 题目： 583. 两个字符串的删除操作 (minDistance)
 * 描述：给定两个单词 word1 和 word2 ，返回使得 word1 和  word2 相同所需的最小步数。
 * 每步 可以删除任意一个字符串中的一个字符。

 示例 1：
 输入: word1 = "sea", word2 = "eat"
 输出: 2
 解释: 第一步将 "sea" 变为 "ea" ，第二步将 "eat "变为 "ea"

 * 链接：https://leetcode.cn/problems/delete-operation-for-two-strings/
 */
public class MinDistance {
    public int minDistance(String word1, String word2) {
        int len1=word1.length(),len2=word2.length();
        int[][]dp=new int[len1+1][len2+1];
        for (int i = 1; i <= len1; i++) {
            for (int j = 1; j <= len2; j++) {
                if(word1.charAt(i-1)==word2.charAt(j-1))
                    dp[i][j]=dp[i-1][j-1]+1;
                else dp[i][j]=Math.max(dp[i][j-1],dp[i-1][j]);
            }
        }
        return len1+len2-2*dp[len1][len2];
    }
}
