package dynamic_programming;

import java.util.Arrays;

/**
 * 题目： 279. 完全平方数 (numSquares)
 * 描述：给你一个整数 n ，返回 和为 n 的完全平方数的最少数量 。
 * 完全平方数 是一个整数，其值等于另一个整数的平方；换句话说，其值等于一个整数自乘的积。例如，1、4、9 和 16 都是完全平方数，而 3 和 11 不是。

 示例 2：
 输入：n = 12
 输出：3
 解释：12 = 4 + 4 + 4

 * 链接：https://leetcode.cn/problems/perfect-squares/
 */
public class NumSquares {
    public int numSquares(int n) {
        int[]dp=new int[n+1];
        double sqrted=Math.sqrt(n);
        int soft_max=(int) sqrted;
        Arrays.fill(dp,n+1);
        dp[0]=0;
        for (int i = 1; i <= soft_max; i++) {
            for (int j = 1; j <= n; j++) {
                int cur= (int) Math.pow(i,2);
                if(j>=cur &&dp[j-cur]!=n+1)
                    dp[j]=Math.min(dp[j],dp[(int) (j-Math.pow(i,2))]+1);
            }
        }
        return dp[n];
    }
}
