package linkedlist;
/**
 * 题目： 82. 删除排序链表中的重复元素 II (deleteDuplicates)
 * 描述：给定一个已排序的链表的头 head ， 删除原始链表中所有重复数字的节点，只留下不同的数字 。返回 已排序的链表 。

 示例 2：
 输入：head = [1,2,3,3,4,4,5]
 输出：[1,2,5]

 * 链接：https://leetcode.cn/problems/remove-duplicates-from-sorted-list-ii/
 */
public class DeleteDuplicates {
    public ListNode deleteDuplicates(ListNode head) {
        if (head == null) {
            return head;
        }

        ListNode dummy = new ListNode(0, head);

        ListNode cur = dummy;
        while (cur.next != null && cur.next.next != null) {
            //cur及之前的元素一定是已经处理好的，如果它的下一个和下下个元素相同，那就删
            if (cur.next.val == cur.next.next.val) {
                int x = cur.next.val;
                //while循环删到没有这个值的元素为止
                while (cur.next != null && cur.next.val == x) {
                    cur.next = cur.next.next;
                }
            } else {
                cur = cur.next;
            }
        }

        return dummy.next;
    }
}
