package linkedlist;

import java.util.Deque;
import java.util.HashMap;
import java.util.LinkedList;

/**
 * 题目： 19. 删除链表的倒数第 N 个结点  (removeNthFromEnd)
 * 描述：给你一个链表，删除链表的倒数第 n 个结点，并且返回链表的头结点。


 * 链接：https://leetcode.cn/problems/remove-nth-node-from-end-of-list/

 */
public class RemoveNthFromEnd {
    public ListNode removeNthFromEnd1(ListNode head, int n) {
        HashMap<Integer,ListNode>map=new HashMap<>();
        int k=0;
        ListNode cur=head;
        while (cur!=null){
            map.put(k++,cur);
            cur=cur.next;
        }
        if(k-n==0)
            return head.next;
        ListNode pre=map.get(k-n-1);
        pre.next= map.get(k-n+1);
        return head;
    }
    //入栈 出栈
    public ListNode removeNthFromEnd(ListNode head, int n) {
        ListNode dummy = new ListNode(0,head);
        Deque<ListNode> stack = new LinkedList<>();
        ListNode cur = dummy;
        while (cur != null) {
            stack.push(cur);
            cur = cur.next;
        }
        for (int i = 0; i < n; ++i) {
            stack.pop();
        }
        ListNode prev = stack.peek();
        prev.next = prev.next.next;
        ListNode ans = dummy.next;
        return ans;
    }
}
