package linkedlist;
/**
 * 题目： 24. 两两交换链表中的节点  (swapPairs)
 * 描述：给你一个链表，两两交换其中相邻的节点，并返回交换后链表的头节点。你必须在不修改节点内部的值的情况下完成本题（即，只能进行节点交换）。


 * 链接：https://leetcode.cn/problems/swap-nodes-in-pairs/

 */
//需重做
public class SwapPairs {
    //只有一个节点或没有节点时无需交换！
    //递归
    public ListNode swapPairs(ListNode head) {
        if (head == null || head.next == null) {
            return head;
        }
        ListNode one = head;
        ListNode two = one.next;
        ListNode three = two.next;

        two.next = one;
        one.next = swapPairs(three);

        return two;
    }
    //迭代，好理解
    public ListNode swapPairs1(ListNode head) {
        ListNode dummyHead = new ListNode(0,head);
        ListNode temp = dummyHead;
        while (temp.next != null && temp.next.next != null) {
            ListNode node1 = temp.next;
            ListNode node2 = temp.next.next;
            temp.next = node2;
            node1.next = node2.next;
            node2.next = node1;
            temp = node1;
        }
        return dummyHead.next;
    }
}
