package matrix;
/**
 * 题目：240. 搜索二维矩阵 II (searchMatrix)
 * 描述：编写一个高效的算法来搜索 m x n 矩阵 matrix 中的一个目标值 target 。该矩阵具有以下特性：
        每行的元素从左到右升序排列。
        每列的元素从上到下升序排列。

 * 链接：https://leetcode.cn/problems/search-a-2d-matrix-ii/
 *
 示例 1:
 输入：matrix = [[1,4,7,11,15],[2,5,8,12,19],[3,6,9,16,22],[10,13,14,17,24],[18,21,23,26,30]], target = 5
 输出：true

 示例 2:
 输入：matrix = [[1,4,7,11,15],[2,5,8,12,19],[3,6,9,16,22],[10,13,14,17,24],[18,21,23,26,30]], target = 20
 输出：false
 */
//高效的方法不会
public class SearchMatrix {
    //矩阵逆时针旋转45，右上角的元素看作树根，左边比他小，右边比他大
    public boolean searchMatrix(int[][] matrix, int target) {
        int row=matrix.length,col=matrix[0].length;
        int i=0,j=col-1;
        while (i<row && j>=0){
            if(target<matrix[i][j])
                j-=1;
            else if(target==matrix[i][j])
                return true;
            else
                i+=1;
        }
        return false;
    }
}
