package tree;

import java.util.ArrayList;
import java.util.List;

/**
 * 题目： 530. 二叉搜索树的最小绝对差 (getMinimumDifference)
 * 描述：给你一个二叉搜索树的根节点 root ，返回 树中任意两不同节点值之间的最小差值 。
 *
 * 差值是一个正数，其数值等于两值之差的绝对值。
 *
 示例 1：
 输入：root = [4,2,6,1,3]
 输出：1

 * 链接：https://leetcode.cn/problems/minimum-absolute-difference-in-bst/
 */
public class GetMinimumDifference {
    void dfs(TreeNode root, List<Integer>list){
        if(root==null)return;
        dfs(root.left,list);
        list.add(root.val);
        dfs(root.right,list);
    }
    public int getMinimumDifference(TreeNode root) {
        List<Integer>list=new ArrayList<>();
        dfs(root,list);
        int min=Integer.MAX_VALUE;
        for (int i = 0; i < list.size()-1; i++) {
            int tp=list.get(i+1)-list.get(i);
            if(tp<min)min=tp;
        }
        return min;
    }
}
