package tree;
/**
 * 题目： 226. 翻转二叉树  (invertTree)
 * 描述：给你一棵二叉树的根节点 root ，翻转这棵二叉树，并返回其根节点。

 * 链接：https://leetcode.cn/problems/invert-binary-tree/

 */
public class InvertTree {
    public void invert(TreeNode root){
        if(root!=null){
            TreeNode temp;
            temp=root.left;
            root.left=root.right;
            root.right=temp;
            invert(root.left);
            invert(root.right);
        }
    }
    public TreeNode invertTree1(TreeNode root) {
        invert(root);
        return root;
    }
    public TreeNode invertTree(TreeNode root) {
        if (root == null) {
            return null;
        }
        TreeNode left = invertTree(root.left);
        TreeNode right = invertTree(root.right);
        root.left = right;
        root.right = left;
        return root;
    }
}
