package tree;
/**
 * 题目： 108. 将有序数组转换为二叉搜索树  (sortedArrayToBST)
 * 描述：给你一个整数数组 nums ，其中元素已经按 升序 排列，请你将其转换为一棵 平衡 二叉搜索树。

 * 链接：https://leetcode.cn/problems/convert-sorted-array-to-binary-search-tree/

 */
public class SortedArrayToBST {
    //分治
    TreeNode func(int left,int right ,int[] nums){
        if(left>right)
            return null;
        int mid=(right+left)/2;
        TreeNode root=new TreeNode(nums[mid]);
        root.left=func(left,mid-1,nums);
        root.right=func(mid+1,right,nums);
        return root;
    }
    public TreeNode sortedArrayToBST(int[] nums) {
        return func(0,nums.length-1,nums);
    }
}
