package trick;
/**
 * 题目： 169. 多数元素 (majorityElement)
 * 描述：给定一个大小为 n 的数组 nums ，返回其中的多数元素。多数元素是指在数组中出现次数 大于 ⌊ n/2 ⌋ 的元素。
 * 你可以假设数组是非空的，并且给定的数组总是存在多数元素。
 *
 示例 1：
 输入：nums = [3,2,3]
 输出：3

 * 链接：https://leetcode.cn/problems/majority-element/
 */
public class MajorityElement {
    public int majorityElement(int[] nums) {
        int candidate = 0, count = 0;
        for (int num : nums) {
            if (count == 0) {
                candidate = num;      // 选举新候选
                count = 1;
            } else if (num == candidate) {
                count++;             // 支持候选者
            } else {
                count--;             // 反对候选者
            }
        }
        return candidate;
    }
}