package twopointers;
/**
 * 题目：283.移动零 (moveZeroes)
 * 描述：给定一个数组 nums，编写一个函数将所有 0 移动到数组的末尾，同时保持非零元素的相对顺序。
 *      请注意 ，必须在不复制数组的情况下原地对数组进行操作。
 * 链接：https://leetcode.cn/problems/move-zeroes/
 *
 示例 1:
 输入: nums = [0,1,0,3,12]
 输出: [1,3,12,0,0]

 示例 2:
 输入: nums = [0]
 输出: [0]
 */
//做出了，但时间复杂度O(N^2)
public class MoveZeroes {
    public void moveZeroes1(int[] nums) {
        for (int i = 0; i < nums.length; i++) {
            if(nums[i]==0){
                int temp=-1;
                for (int j = i+1; j < nums.length; j++) {
                    if(nums[j]!=0){
                        temp=nums[i];
                        nums[i]=nums[j];
                        nums[j]=temp;
                        break;
                    }
                }
            }
        }
    }
    //直接将非0的数字左移即可，再填充剩下的格子为0。cur左边为已处理完毕的
    public void moveZeroes(int[] nums) {
        int cur = 0;
        for (int i = 0; i < nums.length; i++) {
            if (nums[i] != 0) {
                nums[cur] = nums[i];
                cur++;
            }
        }
        for (int i = cur; i < nums.length; i++) {
            nums[i] = 0;
        }
    }
}
